/***************************************************************
 * Name:      TesteWXMain.cpp
 * Purpose:   Code for Application Frame
 * Author:     ()
 * Created:   2008-11-03
 * Copyright:  ()
 * License:
 **************************************************************/

#include "TesteWXMain.h"
#include <wx/msgdlg.h>

//(*InternalHeaders(TesteWXFrame)
#include <wx/intl.h>
#include <wx/string.h>
//*)
#include <string>
#include <iostream>
#include <fstream>
using namespace std;



//helper functions
enum wxbuildinfoformat {
    short_f, long_f };

wxString wxbuildinfo(wxbuildinfoformat format)
{
    wxString wxbuild(wxVERSION_STRING);

    if (format == long_f )
    {
#if defined(__WXMSW__)
        wxbuild << _T("-Windows");
#elif defined(__UNIX__)
        wxbuild << _T("-Linux");
#endif

#if wxUSE_UNICODE
        wxbuild << _T("-Unicode build");
#else
        wxbuild << _T("-ANSI build");
#endif // wxUSE_UNICODE
    }

    return wxbuild;
}

//(*IdInit(TesteWXFrame)
const long TesteWXFrame::ID_BUTTON1 = wxNewId();
const long TesteWXFrame::ID_BUTTON2 = wxNewId();
const long TesteWXFrame::ID_BUTTON3 = wxNewId();
const long TesteWXFrame::ID_STATICTEXT1 = wxNewId();
//*)

BEGIN_EVENT_TABLE(TesteWXFrame,wxFrame)
    //(*EventTable(TesteWXFrame)
    //*)
END_EVENT_TABLE()

TesteWXFrame::TesteWXFrame(wxWindow* parent,wxWindowID id)
{
    //(*Initialize(TesteWXFrame)
    Create(parent, id, wxEmptyString, wxDefaultPosition, wxDefaultSize, wxDEFAULT_FRAME_STYLE, _T("id"));
    Button1 = new wxButton(this, ID_BUTTON1, _("Teste"), wxPoint(32,144), wxDefaultSize, 0, wxDefaultValidator, _T("ID_BUTTON1"));
    Button2 = new wxButton(this, ID_BUTTON2, _("Lê Arquivo"), wxPoint(144,144), wxDefaultSize, 0, wxDefaultValidator, _T("ID_BUTTON2"));
    Button3 = new wxButton(this, ID_BUTTON3, _("Sair"), wxPoint(264,144), wxDefaultSize, 0, wxDefaultValidator, _T("ID_BUTTON3"));
    Msg1 = new wxStaticText(this, ID_STATICTEXT1, _("Label"), wxPoint(56,72), wxSize(304,17), 0, _T("ID_STATICTEXT1"));

    Connect(ID_BUTTON2,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&TesteWXFrame::OnButton2Click);
    Connect(ID_BUTTON3,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&TesteWXFrame::OnButton3Click);
    //*)
}

TesteWXFrame::~TesteWXFrame()
{
    //(*Destroy(TesteWXFrame)
    //*)
}

void TesteWXFrame::OnQuit(wxCommandEvent& event)
{
    Close();
}

void TesteWXFrame::OnAbout(wxCommandEvent& event)
{
    wxString msg = wxbuildinfo(long_f);
    wxMessageBox(msg, _("Welcome to..."));
}

void TesteWXFrame::OnButton2Click(wxCommandEvent& event)
{
    string a;
    ifstream arq;

    arq.open("clubes.txt",ios::in);
    if (!arq.is_open()){
        Msg1->SetLabel(_T("Erro  !!!"));
    }
    else Msg1->SetLabel(_T("Leitura OK  !!!"));

    arq >> a;
    cout << a << endl; // este COUT funciona somente
                       // quando executado no SHELL/CONSOLE
    arq.close();
    // Para converter uma strng do C++ para uma string do WX,
    // faça conforme o exemplo abaixo
    wxString b(wxString::From8BitData(a.c_str()));
    Button1->SetLabel(b);

}

void TesteWXFrame::OnButton3Click(wxCommandEvent& event)
{
    Close();
}
